
theory SplitImpl imports SplitAxms 
begin 


subsection {* Recursive definition of g *}

consts
g :: "(D \<times> R) \<Rightarrow> R"


lemma Ord3 : 
defines "S \<equiv> {(a, b). (fst a = fst b) \<and> (snd a, snd b) \<in> (R_ord (fst b))}"
shows "wf S"
proof -
 have c : "S = same_fst (\<lambda> x. True) R_ord"
 by (simp add: S_def same_fst_def, rule equalityI, rule subsetI, 
     simp add: split_def, rule subsetI, simp add: split_def)
 have "wf (same_fst (\<lambda> x. True) R_ord)" 
 by (rule wf_same_fst, simp add: Ord1)
 with c show ?thesis by simp
qed


recdef g "{(a, b). (fst a = fst b) \<and> (snd a, snd b) \<in> (R_ord (fst b))}"
"g (a, b) = (if (Term (a, b)) then b else (g (a, H (a, b))))" 
(hints recdef_wf: Ord3 recdef_simp: Ord2)



subsection {* Proving properties of g *}


theorem g_prop :
 assumes a: "Inv(a, b)"
 shows "Inv(a, g(a, b)) \<and> Term(a, g(a, b))" 
proof -
 have " Inv(a, b) \<longrightarrow> Inv(a, g(a, b)) \<and> Term(a, g(a, b)) " (is "?P a b") 
 proof (induct a b rule: g.induct, cases)
  fix a b
  assume "Term(a, b)"
  thus "?P a b" by simp
 next
  fix a b
  assume a1: "\<not> Term(a, b)"
  assume "\<not> Term(a, b) \<longrightarrow> ?P a (H (a, b))"
  with a1 have a2: "?P a (H (a, b))" by simp
  show "?P a b"
  proof (rule impI)
   assume "Inv(a, b)"
   with a1 have "Inv(a, H(a, b))" by (simp add: S2)
   with a2 have "Inv (a, g(a, H(a, b))) \<and> Term(a, g(a, H(a, b)))" by simp
   with a1 show "Inv(a, g(a, b)) \<and> Term(a, g(a, b))" by simp
  qed
 qed
with a show ?thesis by simp
qed


(* Main function *)
constdefs
  f :: "D \<Rightarrow> R"
" f x \<equiv> g (x, E x) " 

theorem PostCond : " Inv(x, f x) \<and> Term(x, f x) "
by (unfold f_def, rule g_prop, rule S1)


end