
signature DATATYPE_RECORD =
sig

type InstStruct

datatype Result = Result of {ids : string list,
                             data : InstStruct,
                             intro_consts : string list,
                             class_deps : string list,
                             tycon_deps : string list}

val try_datatype : theory -> string -> Result option
val try_record   : theory -> string -> Result option

val translate_datatype_record : 
((string * mixfix option) Symtab.table -> Context.theory -> 
 (TypeS.TS Symtab.table -> Term.typ -> Term.typ) ->
  TypeS.TS Symtab.table -> Symtab.key Symtab.table ->
  Derive_Thm.AxmImg Symtab.table -> InstStruct ->
 (theory * TypeS.TS Symtab.table * Symtab.key Symtab.table * Derive_Thm.AxmImg Symtab.table)) option

end


structure Datatype_Record =
struct



datatype InstStruct = Datatype of {num : int,
                                   types : (int * (string list * string * mixfix)) list,
                                   constrs : (int * ((string * Term.typ * mixfix) list)) list}
                    | Record of {qname : string,
                                 recname : string,
                                 args : string list,
                                 arity : int,
                                 parent : (Term.typ list * string) option,
                                 fields : (string * Term.typ * mixfix) list}

datatype Result = Result of {ids : string list,
                             data : InstStruct,
                             intro_consts : string list,
                             class_deps : string list,
                             tycon_deps : string list}



fun try_datatype thy tid = NONE

fun try_record thy tid = NONE

val translate_datatype_record = NONE


end